//+------------------------------------------------------------------+
//|                                                        OSMA2.mq4 |
//|                      Copyright  2006,                   Sparrow |
//|                                              /tkalich_s@mail.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, SPARROW"
#property link      "http://tkalich_s@mail.ru/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Orange
#property indicator_color2 Green
//---- input parameters 
extern int Fast=12;
extern int Slow=26;   
extern int Smooth=9;
extern int Times=0;
//---- buffers
double RBuffer[];
double SBuffer[];
double BBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(3);
  
   SetIndexBuffer(2,BBuffer);
   
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM ,0,2);
   SetIndexBuffer(0,RBuffer);
   SetIndexStyle(1,DRAW_HISTOGRAM, 0,2);
   SetIndexBuffer(1,SBuffer);
   
   
//---- name for DataWindow and indicator subwindow label
   short_name="OSMA2("+Fast+","+Slow+","+Smooth+")("+Times+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"Value");
   SetIndexLabel(1,"Value");
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//----
   Comment(" PERIOD=",Fast);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Relative Strength Index                                          |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
   
//----
   if(Bars<=2) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=2;i++) BBuffer[Bars-i]=0.0;
//----
   i=Bars-2-1;
   if(counted_bars>=2) i=Bars-counted_bars-1;
   while(i>=0)
     {
      
      BBuffer[i]=iOsMA(NULL,Times,Fast,Slow,Smooth,PRICE_CLOSE,i);
      if(BBuffer[i]>BBuffer[i+1])
      SBuffer[i]=BBuffer[i];
      else SBuffer[i]=0;
      if(BBuffer[i]<BBuffer[i+1])
      RBuffer[i]=BBuffer[i];
      else RBuffer[i]=0;
      
      
      i--;
     }

   return(0);
  }
//+------------------------------------------------------------------+